﻿Module modRobo



    Public Function VersionEncode(ByVal VersionCode As Long) As String

        '**********************************************************************************************
        '*** encode the result of ftxGetLibVersion and ftxGetRoboTxFwVal
        '**********************************************************************************************

        On Error Resume Next


        '*** variable declaration

        Dim VersionString As String
        Dim VersionStringLen As Integer
        Dim VersionStringMain As String
        Dim VersionStringRel As String
        Dim VersionStringSub As String


        '*** encoding operation

        'converts integer format to binary
        VersionString = System.Convert.ToString(VersionCode, 2)

        VersionStringLen = Len(VersionString)

        'encoding sub version
        If VersionStringLen >= 8 Then
            VersionStringSub = Strings.Right(VersionString, 8)
        Else
            VersionStringSub = "x"
        End If
        'Debug.Print(VersionStringSub)
        VersionString = Strings.Left(VersionString, VersionStringLen - 8)
        VersionStringLen = Len(VersionString)

        'encoding release version
        If VersionStringLen >= 8 Then
            VersionStringRel = Strings.Right(VersionString, 8)
        Else
            VersionStringRel = "x"
        End If
        'Debug.Print(VersionStringRel)
        VersionString = Strings.Left(VersionString, VersionStringLen - 8)

        'encoding main version
        VersionStringMain = Strings.Right(VersionString, 8)
        'Debug.Print(VersionStringMain)

        VersionEncode = System.Convert.ToUInt32(VersionStringMain, 2) & "." & System.Convert.ToUInt32(VersionStringRel, 2) & "." & System.Convert.ToUInt32(VersionStringSub, 2)

    End Function


    Public Sub ListComChannels()

        '**********************************************************************************************
        '*** store alle available COM channels to global variables
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim errCode1 As UInteger
        Dim errCode2 As UInteger

        Dim buff1 As System.Text.StringBuilder = New System.Text.StringBuilder(45)
        Dim buff2 As System.Text.StringBuilder = New System.Text.StringBuilder(45)

        Dim allPorts As UInteger


        '*** init library and write all channels to global variable

        'operation information to operation log
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("*** automatic operation")
        frmHello.OperationLogAddItem("")

        'Check if dll of the class is really available under the given path
        If System.IO.File.Exists(classFtMscLib.dllpath) = True Then
            'DLL file exists
            frmHello.OperationLogAddItem("OK:    access to fischertechnik system library (" & classFtMscLib.dllpath & ") sucsessfull")
        Else
            'DLL file does not exist
            frmHello.OperationLogAddItem("ERROR: access to fischertechnik system library (" & classFtMscLib.dllpath & ") failed")
            frmHello.OperationLogAddItem("       problem solution: copy the file 'ftMscLib.dll' to the named folder")
        End If


        'init library
        errCode1 = classFtMscLib.FtLibDeclarations.ftxInitLib()

        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")

        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    initalization of libarary result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: initalization of libarary result: " & buff1.ToString())
        End If


        'transfer com port definition to global variables
        allPorts = classFtMscLib.FtLibDeclarations.ftxGetAvailableComPorts(classFtMscLib.FtLibConst.ALL_PORTS)
        frmHello.OperationLogAddItem("")

        For xCounter As UInteger = 0 To allPorts - 1

            buff2 = New System.Text.StringBuilder(100)
            buff1 = New System.Text.StringBuilder(100)
            errCode1 = classFtMscLib.FtLibDeclarations.ftxEnumComPorts(xCounter, buff2, 100)

            If (errCode1 < 100) Then
                glComChannels(xCounter) = buff2.ToString()
                frmHello.OperationLogAddItem("OK:    found channel " + buff2.ToString())
            Else
                classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
                frmHello.OperationLogAddItem("ERROR: com channel search: " & buff1.ToString())
            End If

        Next

        'mark end point in las array element
        glComChannels(allPorts) = "EOF"

    End Sub

    Public Sub DoComConnection(ByVal ComSelection)

        '**********************************************************************************************
        '*** do connection to selected COM channel
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim errCode1 As UInteger
        Dim errCode2 As UInteger

        Dim buff1 As System.Text.StringBuilder = New System.Text.StringBuilder(45)

        Dim versInfo As String
        Dim stringLength As UInteger

        Dim currentComputerName As String


        '*** connect RoboTXController for operation readyness

        'operation information to operation log
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("*** manual operation 'connect button'")

        'check if library initialization is OK
        errCode1 = classFtMscLib.FtLibDeclarations.ftxIsLibInit()
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_LIB_IS_INITIALIZED Then
            frmHello.OperationLogAddItem("OK:    initalization check of libarary result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: initalization check of libarary result: " & buff1.ToString())
            Exit Sub
        End If

        'get libary version information number
        versInfo = VersionEncode(classFtMscLib.FtLibDeclarations.ftxGetLibVersion())
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("INFO:  check library (ftMscLib.dll) version (method 1): " & versInfo)

        'get libary version information string
        buff1 = New System.Text.StringBuilder(100)
        stringLength = classFtMscLib.FtLibDeclarations.ftxGetLibVersionStr(buff1, 100)
        frmHello.OperationLogAddItem("INFO:  check library (ftMscLib.dll) version (method 2): " & buff1.ToString)
        frmHello.OperationLogAddItem("INFO:  connection operation will last up to 1 minute, so please be patient ...")

        'extract the connection channel, e.g. 'COM3' without any space character
        glComSelectionMod = Strings.Replace(Strings.Left(ComSelection, 5), " ", "")

        'generate task and start
        Dim comConThread = System.Threading.Tasks.Task.Factory.StartNew(AddressOf DoOpenComDevice)

        'wait until task is ready
        comConThread.Wait()

        'check if handle is active
        errCode1 = classFtMscLib.FtLibDeclarations.ftxIsHandleValid(glFtHdl)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    handle check to RoboTX controller result: " & buff1.ToString())
            glThreadComConOK = True
        Else
            frmHello.OperationLogAddItem("ERROR: handle check to RoboTX controller result: " & buff1.ToString())
            Exit Sub
        End If

        'check com status of a given handle
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetComStatus(glFtHdl)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    communication check to RoboTX controller result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: communication check to RoboTX controller result: " & buff1.ToString())
        End If

        'start transfer area
        errCode1 = classFtMscLib.FtLibDeclarations.ftxStartTransferArea(glFtHdl)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    start transfer area for data exchange result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: start transfer area for data exchange result: " & buff1.ToString())
        End If

        'check if transfer area is active
        errCode1 = classFtMscLib.FtLibDeclarations.ftxIsTransferActiv(glFtHdl)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_THREAD_IS_RUNNING Then
            frmHello.OperationLogAddItem("OK:    transfer area check result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: transfer area check result: " & buff1.ToString())
        End If

        'transfer a message to RoboTXController display
        currentComputerName = System.Windows.Forms.SystemInformation.ComputerName()
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetRoboTxMessage(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, "wireless remote I/O in operation, current master is " & currentComputerName)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    message transfer to RoboTXController result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: message transfer to RoboTXController result: " & buff1.ToString())
        End If


    End Sub

    Public Sub DoComDisonnection()

        '**********************************************************************************************
        '*** do disconnection to active COM channel
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim errCode1 As UInteger
        Dim errCode2 As UInteger

        Dim buff1 As System.Text.StringBuilder = New System.Text.StringBuilder(45)


        '*** shut down operation with active RoboTXController

        'operation information to operation log
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("*** manual operation 'disconnect button'")

        'clear message text on RoboTXController
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetRoboTxMessage(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, "")
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    message transfer to RoboTXController result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: message transfer to RoboTXController result: " & buff1.ToString())
        End If

        'do all waiting jobs before closing
        System.Windows.Forms.Application.DoEvents()
        System.Threading.Thread.Sleep(500)

        'closing operation transfer area
        errCode1 = classFtMscLib.FtLibDeclarations.ftxStopTransferArea(glFtHdl)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    shut down transfer area result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: shut down transfer area result: " & buff1.ToString())
        End If

        'check if transfer area is active
        errCode1 = classFtMscLib.FtLibDeclarations.ftxIsTransferActiv(glFtHdl)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_THREAD_NOT_RUNNING Then
            frmHello.OperationLogAddItem("OK:    transfer area check result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: transfer area check result: " & buff1.ToString())
        End If

        'closing operation connection
        errCode1 = classFtMscLib.FtLibDeclarations.ftxCloseDevice(glFtHdl)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    stop communication result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: stop communication result: " & buff1.ToString())
        End If

        'check if handle is active
        errCode1 = classFtMscLib.FtLibDeclarations.ftxIsHandleValid(glFtHdl)
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_DEVICE_NOT_OPEN Then
            frmHello.OperationLogAddItem("OK:    handle check to RoboTX controller result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: handle check to RoboTX controller result: " & buff1.ToString())
        End If

    End Sub

    Public Sub RoboTXControllerInfo()

        '**********************************************************************************************
        '*** provide information about the used RoboTXController
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim resultRobo As Object
        Dim versInfo As Object
        Dim errCode1 As UInteger
        Dim versionRef As UInteger

        Dim buff1 As System.Text.StringBuilder = New System.Text.StringBuilder(45)


        '*** gathering system information of active RoboTXController

        'get RoboTXController device Name
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetRoboTxDevName(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, buff1, 40)
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller device name result: " & buff1.ToString())

        'get RoboTXController serial number function 1
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetSerialNrStrg(glFtHdl, buff1, 40)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller serial number result (method 1): " & buff1.ToString())

        'get RoboTXController serial number function 2
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetRoboTxSerialStr(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, buff1, 40)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller serial number result (method 2): " & buff1.ToString())

        'get RoboTXController firmware version function 1
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetRoboTxFwStr(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, buff1, 40)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller firmware version result (type 1): " & buff1.ToString())

        'get RoboTXController firmware version function 2
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetRoboTxFwVal(glFtHdl, 0, versionRef)
        versInfo = VersionEncode(versionRef)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller firmware version result (type 2): " & versInfo)

        'get RoboTXController hardware version
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetRoboTxHwStr(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, buff1, 40)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller hardware version result: " & buff1.ToString())

        'get RoboTXController hardware DLL
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetRoboTxDllStr(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, buff1, 40)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller hardware ROBOLIB.DLL version result: " & buff1.ToString())

        'get RoboTXController manufacturer
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetManufacturerStrg(glFtHdl, buff1, 40)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller manufacturer result: " & buff1.ToString())

        'get RoboTXController short name
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetShortNameStrg(glFtHdl, buff1, 40)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller short name result: " & buff1.ToString())

        'get RoboTXController long name
        buff1 = New System.Text.StringBuilder(100)
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetLongNameStrg(glFtHdl, buff1, 40)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller long name result: " & buff1.ToString())

        'get RoboTXController info
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetRoboTxInfo(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER)
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller info result: " & resultRobo)

        'get RoboTXController session id
        resultRobo = classFtMscLib.FtLibDeclarations.ftxGetSessionId()
        frmHello.OperationLogAddItem("INFO:  RoboTX Controller session id result: " & resultRobo)

    End Sub


    Public Sub DoOpenComDevice()

        '**********************************************************************************************
        '*** external thread
        '*** time supervises by tmrWatchDog
        '**********************************************************************************************

        'On Error Resume Next

        '*** variable declaration

        Dim errCode1 As UInteger
        Dim errCode2 As UInteger
        Dim buff1 As System.Text.StringBuilder = New System.Text.StringBuilder(45)


        'try to connect, this command can take endless time in case it is not succsessful
        glFtHdl = classFtMscLib.FtLibDeclarations.ftxOpenComDevice(glComSelectionMod, 38400, errCode1)

        'error analyses
        buff1 = New System.Text.StringBuilder(100)
        errCode2 = classFtMscLib.FtLibDeclarations.ftxGetLibErrorString(errCode1, 1, buff1, 40)
        'try to write the result into the operation log, but it seemd not to be possible while working in a thread
        frmHello.OperationLogAddItem("")
        If errCode1 = classFtMscLib.FtLibConst.FTLIB_ERR_SUCCESS Then
            frmHello.OperationLogAddItem("OK:    connection to RoboTX controller result: " & buff1.ToString())
        Else
            frmHello.OperationLogAddItem("ERROR: connection to RoboTX controller result: " & buff1.ToString())
        End If

    End Sub

End Module
